#-----------------------------------------------------------------
# read data from SPEC
# $Revision: 1.2 $ $Date: 2001/08/13 18:23:06 $
#------- define a command line option -----------------------------
# command line option 
#lappend command(cmdopt) -ICP -icp
# proc to use 
#set command(-ICP) readICPdata
#set command(-icp) readICPdata
#--------define a dialog box entry
# menu label
lappend command(readtypes) "SPEC data files"
# proc for this entry
lappend command(readproc) ReadSPEC
# allowed data types
if {$tcl_platform(platform) == "windows"} {
    lappend command(filterlist) {spec}
} else {
    lappend command(filterlist) {SPEC spec Spec}
}
# DEFINITIONS for these data types
set command(ReadICP_spec_type) "SPEC scan file"
set command(ReadICP_SPEC_type) "SPEC scan file"
set command(ReadICP_Spec_type) "SPEC scan file"

proc ReadSPEC {file} {
    global command
    if {$file == ""} return
#    pleasewait "reading file $file"
    set ret [readSPECdata $file]
#    donewait
    if {$ret != ""} {return $ret}
    showlastentry $command(read_filelist)
}

#--------------------------------------------------------------------------
# load data from SPEC
proc readSPECdata {filename} {
    global graph command
    # signal errors by quitting
    if [catch {
	puts "opening SPEC file $filename"
	set fl [open $filename r]
	set lnum 0
	set command(mode) 0
	set scan 0
	set data {}
	# get a line
	while {[gets $fl line] >= 0} {
	    incr lnum
	    # rescue the incompetent
	    if {$lnum > 50000} {
		return "Read >50,000 lines. Something is wrong!"
	    }
	    if {[string range $line 0 1] == "#S"} {
		# process the last dataset
		if {$data != ""} {
		    catch {
			resetdata $data
			lappend graph(plotlist) $data
			puts "$data: $ptsread valid points read"
		    }
		}
		set command(mode) 1
		set scan [lindex $line 1]
		set data [file root [file tail $filename]]$scan
		initdata $data
		global $data
		set comment {}
		# don't know if points are consecutive
		set ${data}(skip) 1
		set ptsread 0
	    } elseif {$command(mode) == 1} {
		# reading the header
		if {[string range $line 0 1] == "#C"} {
		    append comment [string trim [string range $line 2 end]]
		    set ${data}(title) $comment
		    append comment " "
		} elseif {[string range $line 0 1] == "#N"} {
		    set cols [lindex $line 1]
		} elseif {[string range $line 0 1] == "#L"} {
		    set varlist [lrange $line 1 end]
		    # make a window to select x & y
		    catch {toplevel .ask}
		    eval destroy [winfo children .ask]
		    pack [label .ask.1 \
			    -text "Choose the entries to read\n for scan $scan"] \
			    -side top
		    pack [frame .ask.2] -side top
		    pack [label .ask.2.a -text "X-axis"] -side left
		    eval tk_optionMenu .ask.2.b command(chooseX) $varlist
		    pack .ask.2.b -side left
		    pack [frame .ask.3] -side top
		    pack [label .ask.3.a -text "Y-axis"] -side left
		    eval tk_optionMenu .ask.3.b command(chooseY) $varlist
		    pack .ask.3.b -side left
		    # deal with defaults
		    if {$command(chooseY) == $command(chooseX) \
			&& $command(chooseY) == [lindex $varlist 0]} {
			set command(chooseY) [lindex $varlist 1]
		    }
		    pack [frame .ask.b] -side top
		    pack [button .ask.b.c -text "Continue" \
			    -command "set command(mode) 2; destroy .ask"] -side left
		    pack [button .ask.b.s -text "Skip scan $scan" \
			    -command "set command(mode) 0; destroy .ask"] -side left
		    
		    putontop .ask
		    tkwait window .ask
		    afterputontop
		    set command(Xcol) [lsearch $varlist $command(chooseX)]
		    set command(Ycol) [lsearch $varlist $command(chooseY)]
		    set ${data}(xlabel) $command(chooseX)
		    set ${data}(xunits) $command(chooseX)
		    set ${data}(ylabel) $command(chooseY)
		}
	    } elseif {$command(mode) == 2} {
		# reading the data
		if {[string range $line 0 1] == "#C"} {
		    append comment [string trim [string range $line 2 end]]
		    set ${data}(title) $comment
		    append comment " "
		    continue
		} 
		if {[string range $line 0 7] == "Warning:"} continue
		if {[string range $line 0 0] == "#"} continue
		set x [lindex $line $command(Xcol)] 
		set y [lindex $line $command(Ycol)]
		if {$x != "" && $y != ""} {
		    set esd 0
		    catch {
			expr $x
			expr $y
			lappend ${data}(x) $x
			lappend ${data}(y) $y
			# allow negative values
			catch {set esd [expr sqrt($y)]}
			lappend ${data}(esd) $esd
			incr ptsread
		    }
		}
	    }
	}
    } errmsg] {
	# try to process the data we have read
	catch {
	    resetdata $data
	    lappend graph(plotlist) $data
	    puts "$data: $ptsread valid points read"
	}
	return "SPEC error. Error reading line $lnum: $errmsg"
    }
    resetdata $data
    lappend graph(plotlist) $data
    catch {close $fp} test
    puts "$data: $ptsread valid points read"
    return {}
}
