# write data out in a GSAS file format.
# blame A.McGhie if it does not work. Not B.Toby
# 01/25/2000

lappend command(writetypes) " Simple gsas with esds (.gsas)"
lappend command(writeproc) writegsasdump

proc writegsasdump {data} {
    global graph command
    global $data 
    set filename [file join $command(pwd) ${data}.gsas]
    set fil [open $filename w]

    if {[set ${data}(type)] == "peaks"} {
	# write a peak file
    	puts "Peaks file need a data file for GSAS"
    } else {
	# write a data file in a gsas format
	puts $fil "Automatically generated file $data from CMPR"
        set ibank 1
        # total number of data points
        set nchan [llength [set ${data}(y)] ]
	# should round down (div by 5 for esd)
	set nrec  [expr round ($nchan / 5)  ]          	
	# starting angle in centa degrees
        set bcoef1 [expr 100.0 * [lindex  [set ${data}(x)] 0] ]	
	# step size
        set bcoef2 [expr 100.0 * ([lindex  [set ${data}(x)] 1] - [lindex  [set ${data}(x)] 0]) ]
 	# place holder used twice in BANK lin
        set bcoef3 0 
        set bnk "BANK"
        set const "CONST"
        set endd "ESD"
        # BANK line format
        set line [format "%s %2d %8d%8d %s %10.2f%10.2f%2d%2d %s" $bnk $ibank $nchan $nrec $const $bcoef1 $bcoef2 $bcoef3 $bcoef3 $endd ]
        puts $fil "$line"
     	# line for debugging
        puts "$line" 
        set i 0
        set j 0
	# print ou line by line the intensity and the esd.
        while { $i <  $nrec } {
           incr i
           set line [format "%8.1f%8.1f%8.1f%8.1f%8.1f%8.1f%8.1f%8.1f%8.1f%8.1f" \
	 	[lindex  [set ${data}(y)] $j           ] [lindex  [set ${data}(esd)] $j           ] \
		[lindex  [set ${data}(y)] [expr $j + 1]] [lindex  [set ${data}(esd)] [expr $j + 1]] \
		[lindex  [set ${data}(y)] [expr $j + 2]] [lindex  [set ${data}(esd)] [expr $j + 2]] \
		[lindex  [set ${data}(y)] [expr $j + 3]] [lindex  [set ${data}(esd)] [expr $j + 3]] \
		[lindex  [set ${data}(y)] [expr $j + 4]] [lindex  [set ${data}(esd)] [expr $j + 4]]]
           incr j 5
           puts $fil "$line"
        }
        # print out last line if nchan div 5 remander eq. zero then last line should be zeros.
        for {set i 1} { $i <= 5 } {incr i} {
           if { [lindex  [set ${data}(y)] $j] == {} } {
              set y$i  0.0
              set ye$i 0.0
           } else {
              set y$i  [lindex [set ${data}(y)  ] $j]
              set ye$i [lindex [set ${data}(esd)] $j]
           }
           incr j
        }
        set line [format "%8.1f%8.1f%8.1f%8.1f%8.1f%8.1f%8.1f%8.1f%8.1f%8.1f" \
	 	$y1 $ye1 $y2 $ye2 $y3 $ye3 $y4 $ye4 $y5 $ye5 ]
        puts $fil "$line"
    }  
    close $fil
    return $filename
}
